package com.eladit.hb9eik.blueduo;

import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.PorterDuff;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AbsoluteLayout;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.content.DialogInterface.OnClickListener;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.UUID;


public class MainActivity extends AppCompatActivity {

    private static final int RESULT_SETTINGS = 1;
    private static final int WAIT_CMD=0;
	private static final int DECODE_CMD_0=1;
	private static final int DECODE_CMD=3;
	private static final int TEST_CMD=10;
    private static final int X_min = 0;
    private static final int X_max = 1024;
    private static final int Y_min = -130;
    private static final int Y_max = -50;
    private static final int Div = 9;
    private BluetoothAdapter mBluetoothAdapter;
    private char Cmd=0xFF;
    private char SubCmd=0xFF;
    private int cnt=0;
	private long tuningFrequency;
    private TextView myText, txt_freq;
    private Context context;
    private ArrayList<band> bands;
    private band newBand=null;
    private myButton bandButton=null;

	private char SerialProcessStatus=WAIT_CMD;
    private boolean isConnected=Boolean.FALSE;
    private BluetoothDevice myDevice;
    private BluetoothSocket mySocket;
    private UUID myUuid;
    private InputStream myIn;
    private OutputStream myOut;
    private Thread myLoop;
	private Handler mHandler = new Handler();
    private float[] xvalues = new float[X_max];
    private float[] yvalues = new float[X_max];

    private int mainVol, auxVol, volume=-50;
    private int mode,LSBbw, USBbw,CWbw,AMbw, FMbw, sideTone;
    private int ptt, squelch=-5;
    private int nr=-2, nb=-2, an=-1, att=0;
    private int rssi;
    private int agcAuto, agcAlvl, agcMlvl, agc;
    private int rit=0;
    private long freq=0, oldfreq=0;

    private String bwCW[]={ " ", "2600 Hz", "1500 Hz", "1000 Hz", "500 Hz", "300 Hz", "100 Hz", "100a", "100b", "100c", "100d" };
    private String bwAM[]={ " ", "2500 Hz", "3000 Hz", "3500 Hz", "4000 Hz", "4500 Hz", "5000 Hz", "5500 Hz", "6000 Hz" };
    private String bwFM[]={ " ", "Nar", "Wide", "Data" };
    private String bwSSB[]={ " ", "1600 Hz", "1700 Hz", "1800 Hz", "1900 Hz", "2000 Hz", "2100 Hz", "2200 Hz", "2300 Hz", "2400 Hz", "2500 Hz", "2600 Hz",
        "2700 Hz", "2800 Hz", "2900 Hz", "3000 Hz", "3100 Hz", "4000 Hz", "5000 Hz", "6000 Hz", "D300", "D600", "D1000" };


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        int screenWidth=this.getResources().getDisplayMetrics().widthPixels;
        int screenHeight=this.getResources().getDisplayMetrics().heightPixels;

        int resourceId = getResources().getIdentifier("status_bar_height", "dimen", "android");
        if (resourceId > 0) {
            screenHeight -= getResources().getDimensionPixelSize(resourceId);
        }

        context=this.getApplicationContext();

        myText = (TextView) findViewById(R.id.myText);
        int width=screenWidth;
        int height=screenHeight/10;
        int left=0;
        int top=screenHeight/10;
        myText.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        myText.refreshDrawableState();

        AbsoluteLayout al = (AbsoluteLayout) findViewById(R.id.first);

        bands=new ArrayList<band>(11);
        bands.add( new band(  1800000,  2000000,  1910000,2,"160m"));
        bands.add( new band(  3500000,  3900000,  3690000,2, "80m"));
        bands.add( new band(  7000000,  7200000,  7090000,2, "40m"));
        bands.add( new band( 10100000, 10150000, 10116000,2, "30m"));
        bands.add( new band( 14000000, 14350000, 14285000,3, "20m"));
        bands.add( new band( 18068000, 18168000, 18130000,3, "17m"));
        bands.add( new band( 21000000, 21450000, 21285000,3, "15m"));
        bands.add( new band( 24890000, 24990000, 24950000,3, "12m"));
        bands.add( new band( 28000000, 29700000, 28360000,3, "10m"));
        bands.add( new band( 50000000, 52000000, 50110000,3,  "6m"));
        bands.add( new band(144000000,146000000,144200000,3,  "2m"));
        bands.add( new band( 88000000,108000000, 88100000,5,  "FM"));

        new myLabel(context, al, screenHeight, screenWidth, 2002, "Freq.", 0,  0, 80, 0xFFFFFFFF, 0xFF0000FF, Gravity.CENTER_VERTICAL | Gravity.CENTER_HORIZONTAL, 16 );

        new myLabel(context, al, screenHeight, screenWidth, 2004, "Vol",          1,  0,  9, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2005, "Mod USB",      1,  9,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2003, "BW 6000Hz",    1, 16, 13, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL ,12 );
        new myLabel(context, al, screenHeight, screenWidth, 2006, "NR Off",       1, 29,  9, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2007, "NB Off",       1, 38,  9, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2008, "AN Off",       1, 47,  9, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2009, "AGC Off",      1, 56, 13, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );
        new myLabel(context, al, screenHeight, screenWidth, 2010, "Squelch Off",  1, 69, 11, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12 );

        new myLabel(context, al, screenHeight, screenWidth, 3001, "",             2, 71,  9, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 10 );

        new myButton(context, al, screenHeight, screenWidth, 1001, "PTT",  3,  8, 0xFFFF0000, this );
        new myButton(context, al, screenHeight, screenWidth, 1002, "TUNE", 3,  9, 0xFFFF0000, this );
        new myButton(context, al, screenHeight, screenWidth, 1003, "CW-",  3, 10, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1004, "CW+",  3, 11, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1005, "6m",   4,  8, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1006, "2m",   4,  9, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1007, "MUTE", 4, 10, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1008, "LSB",  4, 11, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1009, "15m",  5,  8, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1010, "12m",  5,  9, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1011, "10m",  5, 10, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1012, "USB",  5, 11, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1013, "30m",  6,  8, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1014, "20m",  6,  9, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1015, "17m",  6, 10, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1061, "AM",   6, 11, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1022, "Set",  7,  0, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1022, "NR",   7,  1, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1023, "NB",   7,  2, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1024, "AN",   7,  3, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1025, "AGC",  7,  4, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1026, "RIT",  7,  5, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1027, "SQ",   7,  6, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1028, "BW",   7,  7, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1017, "160m", 7,  8, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1018, "80m",  7,  9, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1029, "40m",  7, 10, 0xFF000000, this );
        new myButton(context, al, screenHeight, screenWidth, 1020, "FM",   7, 11, 0xFF000000, this );

        LinearLayout sm = (LinearLayout) findViewById(R.id.smeter);
        width=screenWidth*2/12;
        height=screenHeight*2/16;
        left=screenWidth*17/24;
        top=screenHeight*7/32;
        sm.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        sm.refreshDrawableState();
        plot smeter = new plot(this,height,width);
        smeter.setId(300);
        sm.addView(smeter);
        smeter.NewData(0,0);

        LinearLayout lp = (LinearLayout) findViewById(R.id.graphcontainer);
        width=screenWidth*8/12;
        height=screenHeight*21/32;
        left=0;
        top=screenHeight*7/32;
        lp.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        lp.refreshDrawableState();

        plot2d graph = new plot2d(this,xvalues,yvalues,1,height,width);
        for (int i = 0; i < X_max; i++) {
            xvalues[i] = (float) i;
        }
        graph.watrfalactive = 1;
        graph.minx = X_min;
        graph.maxx = X_max;
        graph.maxy = Y_max;
        graph.miny = Y_min;
        graph.dx = Div;
        graph.setOnTouchListener(graph);
        graph.setId(200);
        lp.addView(graph);
        graph.NewData(xvalues, yvalues);

        // get service
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter == null) {
            AlertBox("Fatal Error", " - Device does not support Bluetooth");
        }
        myText.setText("Started"+Integer.toString(screenHeight)+"-"+Integer.toString(screenWidth));
    }


    @Override
    public void onResume() {
        super.onResume();

        Set<BluetoothDevice> pairedDevices = mBluetoothAdapter.getBondedDevices();

        // If there are paired devices
        myText.append(" - Paired");

        if (pairedDevices.size() > 0) {
            // Loop through paired devices
            myText.append(" - Search");
            myText.setVisibility(View.INVISIBLE);
            for (BluetoothDevice device : pairedDevices) {
                if (device.getName().equals(getString(R.string.BlueDuo))) {
                    myText.append(" - Discovered");
                    myDevice = device;
                    try {
                        UUID myUuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
                        mySocket = myDevice.createInsecureRfcommSocketToServiceRecord(myUuid);
                        myText.append(" - Socket created");
                    } catch (IOException e) {
                        AlertBox("Fatal Error", "Socket creation error\n" + e.toString());
                    }
                    mBluetoothAdapter.cancelDiscovery();
                    myText.append(" - Discovery cancelled");
                    try {
                        mySocket.connect();
                        myText.append(" - Connected");
                    } catch (IOException e) {
                        AlertBox("Fatal Error", "Connect error\n" + e.toString());
                    }
                    try {
                        myIn = mySocket.getInputStream();
                        myText.append(" - GetInputStream");
                    } catch (IOException e) {
                        AlertBox("Fatal Error", "GetInputStream error\n" + e.toString());
                    }
                    try {
                        myOut = mySocket.getOutputStream();
                        myText.append(" - GetOutputStream");
                    } catch (IOException e) {
                        AlertBox("Fatal Error", "GetOutputStream error\n" + e.toString());
                    }
                    myLoop = new mLoopdati(myIn, myOut);
                    myText.append(" - StartingLoop");
                    myLoop.start();
                    isConnected=Boolean.TRUE;
                    break;
                }
            }
            if(!isConnected) {
                AlertBox("Warning", "No ELAD device found");
            }
        } else {
            AlertBox("Warning", "No devices found o no bluetooth activated");
        }
    }

    @Override
    public void onStop() {
        if( isConnected ) {
            myLoop.interrupt();
        }
        System.exit(0);
        super.onStop();
    }


    public OutputStream getOutStream() {
        return myOut;
    }
    public List<band> getBands() {
        return bands;
    }
    public int getAgcAuto() {
        return agcAuto;
    }
    public int getNb() {
        return nb;
    }
    public void setNb(int nb) {
        this.nb=nb;
    }
    public int getNr() {
        return nr;
    }
    public void setNr(int nr) {
        this.nr=nr;
    }
    public int getAn() {
        return an;
    }
    public void setAn(int an) {
        this.an=an;
    }
    public int getRit() {
        return rit;
    }
    public void setRit(int rit) {
        this.rit=rit;
    }
    public int getMod() {
        return mode;
    }
    public void setMod(int mode) {
        this.mode=mode;
    }
    public int getSq() {
        return squelch;
    }
    public void setSq(int sq) {
        this.squelch=sq;
    }
    public int getVolume() {
        return volume;
    }
    public long getFreq() {
        return freq;
    }
    public void setNewBand( band newBand, myButton bandButton ){
        this.newBand=newBand;
        this.bandButton=bandButton;
    }
    public void setFreq(int freq, band newBand, myButton bandButton ) {
        this.newBand=newBand;
        this.bandButton=bandButton;
        String catcmd = String.format("CF%011d;",freq);
        try {
            this.myOut.write(catcmd.getBytes());
            this.myOut.flush();
        } catch (IOException e) {
            AlertBox("Error", "Serial cat send error\n" + catcmd + "\n" + e.toString());
        }
    }
    void setBand( long oldFreq) {
        List<band> bands=this.bands;
        band from=null;
        for( int j=0; j<bands.size(); j++ ) {
            band ba = bands.get(j);
            if (ba.getStart() <= oldFreq && ba.getEnd() >= oldFreq) {
                from = ba;
            }
            if (from != null) {
                break;
            }
        }
        if( from != null ){
            from.setFreq((int)oldFreq);
            from.setNr(this.nr);
            from.setNb(this.nb);
            from.setAn(this.an);
            from.setSq(this.squelch);
            from.setMod(this.mode);
        }
    }
    public void setAll( band newBand, myButton button ){
        setNr(-newBand.getNr());
        button.NRdown();
        setNb(-newBand.getNb());
        button.NBdown();
        setAn(-newBand.getAn());
        button.ANdown();
        setSq(-newBand.getSq());
        button.SQdown();
        button.SQup();
        int mod=newBand.getMod();
        setMod(mod);
        String catCmd;
        switch( mod ) {
            case 1:
                catCmd="MD5;";
                break;
            case 2:
                catCmd="MD1;";
                break;
            case 3:
                catCmd="MD2;";
                break;
            case 4:
                catCmd="MD3;";
                break;
            case 5:
                catCmd="MD4;";
                break;
            case 6:
                catCmd="MD7;";
                break;
            default:
                catCmd="";
        }
        button.sendCmd( catCmd );
        setNewBand(null, null);
    }

    public void setVolume(int volume) {
        this.squelch=volume;
    }
    public int getPtt() {
        return ptt;
    }
    public int getResultSettings() {
        return RESULT_SETTINGS;
    }

    public void AlertBox( String title, String message ){
        new AlertDialog.Builder(this)
                .setTitle( title )
                .setMessage( message + "\nPress OK to exit." )
                .setPositiveButton("OK", new OnClickListener() {
                    public void onClick(DialogInterface arg0, int arg1) {
                        isConnected = Boolean.FALSE;
                        finish();
                    }
                }).show();
    }

	private class mLoopdati extends Thread {
        private InputStream inS;
        private OutputStream outS;

        public mLoopdati(InputStream in, OutputStream out) {
            myText.append(" - InitLoop");
            inS = in;
            outS = out;
        }

        public void run() {
            int i, idx = 0;
            int len;
            int DataLength = 9;
            byte[] rbuf = new byte[8096];

            myText.append(" - LoopStarted");

            for (; ; ) {//this is the main loop for transferring
                switch (SerialProcessStatus) {
                    case TEST_CMD:
                        break;
                    case WAIT_CMD:
                        try {
                            len = inS.read(rbuf, 0, 1);
                        } catch (IOException e1) {
                            len = 0;
                        }
                        if (len > 0) {
                            if (rbuf[0] == 0 || rbuf[0] == 1) {
                                Cmd = (char) rbuf[0];
                                SerialProcessStatus = DECODE_CMD_0;
                            }
                        }
                        break;
                    case DECODE_CMD_0:
                        for (int j = 0; j < 5; j += len) {
                            try {
                                len = inS.read(rbuf, j, 5-j);
                            } catch (IOException e1) {
                                SerialProcessStatus = WAIT_CMD;
                                break;
                            }
                        }
                        if( SerialProcessStatus == WAIT_CMD) {
                            break;
                        }
                        char DataLengthStr[] = new char[4];
                        DataLengthStr[0] = (char) (rbuf[4] | 0x30);
                        DataLengthStr[1] = (char) (rbuf[3] | 0x30);
                        DataLengthStr[2] = (char) (rbuf[2] | 0x30);
                        DataLengthStr[3] = (char) (rbuf[1] | 0x30);
                        SubCmd = (char) rbuf[0];
                        String StrLenght = new String(DataLengthStr);
                        try {
                            DataLength = Integer.parseInt(StrLenght, 16);
                        } catch (NumberFormatException e) {
                            SerialProcessStatus = WAIT_CMD;
                            break;
                        }
                        SerialProcessStatus = DECODE_CMD;
                        break;
                    case DECODE_CMD:
                        switch (Cmd) {
                            case 0x00: //Spettro
                                if (SubCmd == 0x30) {    //Spettro RF
                                    for( int j=0; j<DataLength; j+=len ) {
                                        try {
                                            len = inS.read(rbuf, j, DataLength-j);
                                        } catch (IOException e1) {
                                            SerialProcessStatus = WAIT_CMD;
                                            break;
                                        }
                                    }
                                    if( SerialProcessStatus == WAIT_CMD) {
                                        break;
                                    }
                                    for (idx = 0; idx < DataLength; idx++) {
                                        int r = rbuf[idx] & 0xFF;
                                        yvalues[idx] = (float) (r - 192.0);
                                    }
                                    mHandler.post(new Runnable() {
                                        public void run() {
                                            plot2d gr = (plot2d) findViewById(200);
                                            gr.putOutS(outS);
                                            gr.putTuningFrequency(tuningFrequency);
                                            gr.NewData(xvalues, yvalues);
                                            gr.refreshDrawableState();
                                        }
                                    });
                                }
                                break;
                            case 0x01:
                                if (SubCmd == 0x30) { // Frequenza di sintonia
                                    for( int j=0; j<DataLength; j+=len ) {
                                        try {
                                            len = inS.read(rbuf, j, DataLength-j);
                                        } catch (IOException e1) {
                                            SerialProcessStatus = WAIT_CMD;
                                            break;
                                        }
                                    }
                                    if( SerialProcessStatus == WAIT_CMD) {
                                        break;
                                    }
                                    char tuningFrequencyStr[] = new char[9];
                                    tuningFrequencyStr[0] = (char) (rbuf[0] | 0x30);
                                    tuningFrequencyStr[1] = (char) (rbuf[1] | 0x30);
                                    tuningFrequencyStr[2] = (char) (rbuf[2] | 0x30);
                                    tuningFrequencyStr[3] = (char) (rbuf[3] | 0x30);
                                    tuningFrequencyStr[4] = (char) (rbuf[4] | 0x30);
                                    tuningFrequencyStr[5] = (char) (rbuf[5] | 0x30);
                                    tuningFrequencyStr[6] = (char) (rbuf[6] | 0x30);
                                    tuningFrequencyStr[7] = (char) (rbuf[7] | 0x30);
                                    tuningFrequencyStr[8] = (char) (rbuf[8] | 0x30);
                                    tuningFrequency = 0;
                                    tuningFrequency |= tuningFrequencyStr[0] - 0x30;
                                    for (i = 1; i < 9; i++) {
                                        tuningFrequency <<= 4;
                                        tuningFrequency |= tuningFrequencyStr[i] - 0x30;
                                    }
                                    final String mFreq = "Frequency: " + tuningFrequency + " Hz";
                                    oldfreq=freq;
                                    freq=tuningFrequency;
                                    if( DataLength>9 && (rbuf[9]&0xF0)==0x30 ) {
                                        mode = rbuf[9] & 0x0F;
                                    }
                                    if( DataLength>10 && (rbuf[10]&0xF0)==0x30 ) {
                                        int j = ((rbuf[10] & 0x08)>>3);
                                        mainVol = j>0?-1:1;
                                        auxVol  = (rbuf[10] & 0x04)>>2; // daverificare
                                        sideTone= (rbuf[10] & 0x02)>>1; // daverificare
                                        j = rbuf[10] & 0x01;
                                        ptt = j>0?j:-1;
                                    }
                                    /*
                                    if( ptt >0 ) {
                                        layer |= 0x08;
                                    } else {
                                        layer &= 0xF7;
                                    }
                                    */
                                    if( DataLength>11 && (rbuf[11]&0xF0)==0x30 ) {
                                        int j = rbuf[11] & 0x0F;
                                        squelch = j > 0 ? j: squelch < 0 ? squelch : -squelch;
                                    }
                                    if( DataLength>13 && (rbuf[12]&0xF0)==0x30 && (rbuf[13]&0xF0)==0x30 ) {
                                        agcAuto = (rbuf[12] & 0x04)>>2;
                                        int k = rbuf[12] & 0x03;
                                        agcAlvl = k > 0 ? k: agcAlvl < 0 ? agcAlvl : -agcAlvl;
                                        int l = rbuf[13] & 0x0F;
                                        agcMlvl = l > 0 ? l: agcMlvl < 0 ? agcMlvl : -agcMlvl;
                                        agc = agcAuto ==0 ? k+1 : l+5;
                                    }
                                    if( DataLength>14 && (rbuf[14]&0xF0)==0x30 ) {
                                        int j = rbuf[14] & 0x0F;
                                        nr = j > 0 ? j: nr < 0 ? nr : -nr;
                                    }
                                    if( DataLength>15 && (rbuf[15]&0xF0)==0x30 ) {
                                        int j = rbuf[15] & 0x0F;
                                        nb = j > 0 ? j: nb < 0 ? nb : -nb;
                                    }
                                    if( DataLength>19 && (rbuf[16]&0xE0)==0x20 && (rbuf[17]&0xE0)==0x20 && (rbuf[18]&0xF0)==0x30 && (rbuf[19]&0xE0)==0x20 ) {
                                        LSBbw = (rbuf[16] & 0x1F)+1;
                                        USBbw = (rbuf[17] & 0x1F)+1;
                                        CWbw  = (rbuf[18] & 0x0F)+1;
                                        AMbw  = ((rbuf[19] & 0x1C)>>2)+1;
                                        FMbw  = (rbuf[19] & 0x03)+1;
                                    }
                                    if( DataLength>20 && (rbuf[20]&0xF0)==0x30 ) {
                                        int j = (rbuf[20] & 0x06)>>1;
                                        an = j > 0 ? j: an < 0 ? an : -an;
                                        // works->rit = CmdBuffer[21] & 0x01; // not working
                                    }
                                    if( DataLength>21 ) {
                                        int j=rbuf[21] & 0xFF;
                                        rssi =  j-192-31+(att>0?12:0);
                                        // rssi=(int)yvalues[512];
                                    }
                                    if( DataLength>22 ) {
                                        int j = rbuf[22] & 0x7F;
                                        volume = j > 0 ? j: volume < 0 ? volume: -volume;
                                    }
                                    mHandler.post(new Runnable() {
                                        public void run() {
                                            TextView txtFREQ = (TextView) findViewById(2002);
                                            txtFREQ.setText(mFreq);
                                            if( ptt >0 ) {
                                                txtFREQ.setBackgroundColor(0xFFFF0000);
                                            } else {
                                                txtFREQ.setBackgroundColor(0xFF0000FF);
                                            }
                                            TextView data = (TextView) findViewById(2004);
                                            if(volume >0 ) {
                                                data.setText("Vol " + Integer.toString(volume));

                                            } else {
                                                data.setText("MUTE");
                                            }
                                            data = (TextView) findViewById(2005);
                                            String pbw;
                                            switch( mode ) {
                                                case 1:
                                                    data.setText("AM");
                                                    pbw = bwAM[AMbw];
                                                    break;
                                                case 2:
                                                    data.setText("LSB");
                                                    pbw = bwSSB[LSBbw];
                                                    break;
                                                case 3:
                                                    data.setText("USB");
                                                    pbw = bwSSB[USBbw];
                                                    break;
                                                case 4:
                                                    data.setText("CW+");
                                                    pbw = bwCW[CWbw];
                                                    break;
                                                case 5:
                                                    data.setText("FM");
                                                    pbw = bwFM[FMbw];
                                                    break;
                                                case 6:
                                                    data.setText("CW-");
                                                    pbw = bwCW[CWbw];
                                                    break;
                                                default:
                                                    pbw="";
                                            }
                                            data = (TextView) findViewById(2003);
                                            data.setText( "BW "+pbw);
                                            data = (TextView) findViewById(2006);
                                            if( nr>0) {
                                                data.setText("NR " + Integer.toString(nr));
                                            } else {
                                                data.setText("NR Off");
                                            }
                                            data = (TextView) findViewById(2007);
                                            if( nb>0) {
                                                data.setText("NB " + Integer.toString(nb));
                                            } else {
                                                data.setText("NB Off");
                                            }
                                            data = (TextView) findViewById(2008);
                                            if( an>0) {
                                                data.setText("AN " + Integer.toString(an));
                                            } else {
                                                data.setText("AN Off");
                                            }
                                            data = (TextView) findViewById(2009);
                                            if( agcAuto==0) {
                                                if( agcAlvl==1 ) {
                                                    data.setText("AGC Slow");
                                                } else if( agcAlvl==2 ) {
                                                    data.setText("AGC Medium");
                                                } else if( agcAlvl==3 ) {
                                                    data.setText("AGC Fast");
                                                }
                                            } else {
                                                if( agcMlvl >0 ) {
                                                    data.setText("Gain " + Integer.toString(agcMlvl));
                                                } else {
                                                    data.setText("Gain Off");
                                                }
                                            }
                                            data = (TextView) findViewById(2010);
                                            if( squelch>0) {
                                                data.setText("Squelch " + Integer.toString(squelch));
                                            } else {
                                                data.setText("Squelch Off");
                                            }
                                            int s=(rssi+127)/6;
                                            if( s<0 ) {
                                                s=0;
                                            }
                                            if( s>9 ) {
                                                s=9;
                                            }
                                            int d=rssi+73;
                                            if( d<0 ) {
                                                d=0;
                                            }
                                            String value;
                                            if( d==0 ) {
                                                value="S"+Integer.toString(s);
                                            } else {
                                                value="S"+Integer.toString(s)+"+"+Integer.toString(d);
                                            }
                                            plot sm = (plot) findViewById(300);
                                            sm.NewData(s, d);
                                            sm.refreshDrawableState();
                                            data = (TextView) findViewById(3001);
                                            data.setText(value+"\n"+Integer.toString(rssi)+" dBm");
                                            if( oldfreq!=freq) {
                                                setBand(oldfreq);
                                                if( newBand!=null ) {
                                                    setAll(newBand,bandButton);
                                                }
                                            }
                                        }
                                    });
                                }
                                break;
                        }//end switch decode command
                        SerialProcessStatus = WAIT_CMD;
                        idx = 0;
                        break;
                } //end switch
            }
        }
    }
}
