package com.eladit.hb9eik.blueduo;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AbsoluteLayout;
import android.widget.Button;

import java.io.IOException;
import java.io.OutputStream;
import java.util.List;

public class myButton implements View.OnTouchListener{
    static private int maxrow=8;
    static private int maxcol=12;
    private int top;
    private int left;
    private int height;
    private int width;
    private int textSize;
    private MainActivity app;
    private String name;
    private Button bt;
    private int resultSettings;

    myButton(Context context, AbsoluteLayout al, int screenHeight, int screenWidth, int id, String name, int row, int col, int color, MainActivity app  ){
        bt = new Button(context);
        bt.setId( id );
        bt.setText( name );
        //bt.setBackgroundColor(0xFFBBBBBB);
        width=screenWidth/maxcol;
        height=screenHeight/maxrow;
        left=screenWidth*col/maxcol;
        top=screenHeight*row/maxrow;
        bt.setIncludeFontPadding(false);
        bt.setPadding(0,0,0,0);
        textSize=9*screenWidth/800;
        bt.setTextSize(textSize);
        bt.setTypeface(null,Typeface.BOLD);
        bt.setTextColor(color);
        al.addView(bt, new AbsoluteLayout.LayoutParams(width, height, left, top));
        al.refreshDrawableState();
        this.app=app;
        this.name=name;
        bt.setOnTouchListener(this);
    }

    public boolean onTouch(View v, MotionEvent event) {
        switch (event.getAction()) {
            case MotionEvent.ACTION_DOWN:
                if(  name.equals("NB") ) {
                    NBdown();
                } else if( name.equals("NR") ) {
                    NRdown();
                } else if( name.equals("AN") ) {
                    ANdown();
                } else if( name.equals("AGC") ) {
                    AGCdown();
                } else if( name.equals("RIT") ) {
                    RITdown();
                } else if( name.equals("SQ") ) {
                    SQdown();
                } else if( name.equals("BW") ) {
                    BWdown();
                } else if( name.equals("MUTE") ) {
                    MUTEdown();
                } else if( name.equals("CW-") ) {
                    CWMdown();
                } else if( name.equals("CW+") ) {
                    CWPdown();
                } else if( name.equals("LSB") ) {
                    LSBdown();
                } else if( name.equals("USB") ) {
                    USBdown();
                } else if( name.equals("AM") ) {
                    AMdown();
                } else if( name.equals("FM") ) {
                    FMdown();
                } else if( name.equals("PTT") ) {
                    PTTdown();
                } else if( name.equals("TUNE") ) {
                    TUNEdown();
                } else if( name.equals("160m") ) {
                    BANDset("160m");
                } else if( name.equals("80m") ) {
                    BANDset("80m");
                } else if( name.equals("40m") ) {
                    BANDset("40m");
                } else if( name.equals("30m") ) {
                    BANDset("30m");
                } else if( name.equals("20m") ) {
                    BANDset("20m");
                } else if( name.equals("17m") ) {
                    BANDset("17m");
                } else if( name.equals("15m") ) {
                    BANDset("15m");
                } else if( name.equals("12m") ) {
                    BANDset("12m");
                } else if( name.equals("10m") ) {
                    BANDset("10m");
                } else if( name.equals("6m") ) {
                    BANDset("6m");
                } else if( name.equals("2m") ) {
                    BANDset("2m");
                }
                break;
            case MotionEvent.ACTION_UP:
                if(  name.equals("NB") ) {
                    NBup();
                } else if( name.equals("NR") ) {
                    NRup();
                } else if( name.equals("AN") ) {
                    ANup();
                } else if( name.equals("AGC") ) {
                    ACGup();
                } else if( name.equals("RIT") ) {
                    RITup();
                } else if( name.equals("SQ") ) {
                    SQup();
                } else if( name.equals("BW") ) {
                    BWup();
                }
                break;
        }
        return false;
    }
    public void AlertBox(Context context, String title, String message ){
        new AlertDialog.Builder(context)
                .setTitle( title )
                .setMessage( message + "\nPress OK to exit." )
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface arg0, int arg1) { }
                }).show();
    }

    void NBdown(){
        String catCmd;
        int nb=app.getNb();
        if( nb>0 ) {
            catCmd="NK0000;";
        } else {
            catCmd="NK0"+String.format("%03d",-nb)+";";
        }
        app.setNb(-nb);
        catCmd+="GM026;";
        sendCmd( catCmd );
    }
    void NBup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void NRdown(){
        String catCmd;
        int nr=app.getNr();
        if( nr>0 ) {
            catCmd="NC0000;";
        } else {
            catCmd="NC0"+String.format("%03d",-nr)+";";
        }
        app.setNr(-nr);
        catCmd+="GM025;";
        sendCmd( catCmd );
    }
    void NRup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void ANdown(){
        String catCmd;
        int an=app.getAn();
        if( an>0 ) {
            catCmd="NO0000;";
        } else {
            catCmd="NO0"+String.format("%03d",-an)+";";
        }
        app.setAn(-an);
        catCmd+="GM027;";
        sendCmd( catCmd );
    }
    void ANup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void AGCdown(){
        String catCmd;
        if( app.getAgcAuto()==0 ) {
            catCmd="GC1;GM024;";
        } else {
            catCmd="GC0;GM023;";
        }
        sendCmd( catCmd );
    }
    void ACGup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void RITdown(){
        String catCmd;
        int rit=app.getRit();
        if( rit>0 ) {
            catCmd="RT0;";
        } else {
            catCmd="RT1;";
        }
        catCmd+="GM063;";
        sendCmd( catCmd );
    }
    void RITup(){
        String catCmd="GM060;";
        sendCmd( catCmd );
    }
    void SQdown(){
        String catCmd;
        int sq=app.getSq();
        if( sq>0 ) {
            catCmd="SQ0000;";
        } else {
            catCmd="SQ0"+String.format("%03d",-sq)+";";
        }
        app.setSq(-sq);
        catCmd+="GM021;";
        sendCmd( catCmd );
    }
    void SQup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void BWdown(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void BWup(){
        String catCmd="GM020;";
        sendCmd( catCmd );
    }
    void MUTEdown(){
        String catCmd;
        int volume=app.getVolume();
        if( volume>0 ) {
            catCmd="VM000;";
        } else {
            catCmd="VM"+String.format("%03d",-volume)+";";
        }
        app.setVolume(-volume);
        sendCmd( catCmd );
    }
    void CWMdown(){
        String catCmd="MD7;";
        sendCmd( catCmd );
    }
    void CWPdown(){
        String catCmd="MD3;";
        sendCmd( catCmd );
    }
    void LSBdown(){
        String catCmd="MD1;";
        sendCmd( catCmd );
    }
    void USBdown(){
        String catCmd="MD2;";
        sendCmd( catCmd );
    }
    void AMdown(){
        String catCmd="MD5;";
        sendCmd( catCmd );
    }
    void FMdown(){
        String catCmd="MD4;";
        sendCmd( catCmd );
    }
    void PTTdown(){
        int ptt=app.getPtt();
        String catCmd;
        if( ptt>0 ) {
            catCmd="RX;";
        } else {
            catCmd="RX;TX0;";
        }
        sendCmd( catCmd );
    }
    void TUNEdown(){
        int ptt=app.getPtt();
        String catCmd;
        if( ptt>0 ) {
            catCmd="RX;";
        } else {
            catCmd="RX;TX2;";
        }
        sendCmd( catCmd );
    }
    void BANDset( String bandname ) {
        List<band> bands=app.getBands();
        band to=null;
        for( int j=0; j<bands.size(); j++ ) {
            band ba = bands.get(j);
            if (bandname.equals(ba.getName())) {
                to = ba;
            }
            if (to != null) {
                break;
            }
        }
        if( to != null ){
            app.setFreq(to.getFreq(),to,this);
        }
    }
    void sendCmd(String catCmd ) {
        try {
            OutputStream outS=app.getOutStream();
            outS.write(catCmd.getBytes());
            outS.flush();
        } catch (IOException e) {
            AlertBox(app, "Error", "Serial cat send error\n" + catCmd + "\n" + e.toString());
        }
    }

}
